//Include the LCD Library.
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Debounce.h>
#include <esp_now.h>
#include <WiFi.h>

//set screen 
#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels
// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, -1);


Debounce Button1(GPIO_NUM_15, 100, true );
Debounce Button2(GPIO_NUM_2, 100, true );
Debounce Button3(GPIO_NUM_0, 100, true );
Debounce Button4(GPIO_NUM_4, 100, true );
Debounce Button5(GPIO_NUM_16, 100, true );
Debounce Button6(GPIO_NUM_17, 100, true );
Debounce Button7(GPIO_NUM_13, 100, true );


int b1_state;
int b2_state;
int b3_state;
int b4_state;
int b5_state;
int b6_state;

int s1[7];
int p1_state = 0;
int p2_state = 0;
int password1[4];
int password2[4];
int input1[4];
int c1 = 0;
int check1 = 0;
int buzzer = 0;
int park = 0;

int cnt = 0;
int i=0;
char pw1[10];
char res1[10];
int sc1=0;  //mode of screen1 -> 0 = not set pw



int ledState = HIGH;         // the current state of the output pin
int buttonState;             // the current reading from the input pin
int lastButtonState = LOW;   // the previous reading from the input pin
unsigned long lastDebounceTime = 0;  // the last time the output pin was toggled
unsigned long debounceDelay = 50;    // the debounce time; increase if the output flickers

uint8_t broadcastAddress[] = {0xE8, 0x68, 0xE7, 0x19, 0xAA, 0xB0};//ส่งไปหาเฉพาะ mac address

typedef struct struct_message { // สร้างตัวแปรแพ็จเกจแบบ struct
  int is_park1;
  int is_park2;
  int is_password_correct;
  int d;
} struct_message;

struct_message myData; // ตัวแปรแพ็คเกจที่ต้องการส่ง

int password_state = 0;

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) {
  //Serial.print("\r\nLast Packet Send Status:\t");
  //Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Delivery Success" : "Delivery Fail");
}


void setup() {
  // initialize the pushbutton pin as an input:
  pinMode(GPIO_NUM_15, INPUT_PULLUP);
  pinMode(GPIO_NUM_2, INPUT_PULLUP);
  pinMode(GPIO_NUM_0, INPUT_PULLUP);
  pinMode(GPIO_NUM_4, INPUT_PULLUP);
  pinMode(GPIO_NUM_16, INPUT_PULLUP);
  pinMode(GPIO_NUM_17, INPUT_PULLUP);
  pinMode(GPIO_NUM_13, INPUT_PULLUP);
 
  WiFi.mode(WIFI_STA);

  Serial.begin(115200);
  
  if(!display.begin(SSD1306_SWITCHCAPVCC, 0x3C)) { // Address 0x3D for 128x64
    Serial.println(F("SSD1306 allocation failed"));
    for(;;);
  }
  delay(500);
  //start 
  display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(0, 10);
  // Display static text
  display.println("Hello !!!");
  display.display(); 

  // สั่งให้เริ่ม ESP-NOW
  if (esp_now_init() != ESP_OK) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }

  //เมื่อส่งให้ทำฟังก์ชั่น OnDataSend ที่เราสร้างขึ้น
  esp_now_register_send_cb(OnDataSent);

  // Register peer
  esp_now_peer_info_t peerInfo;
  memcpy(peerInfo.peer_addr, broadcastAddress, 6);
  peerInfo.channel = 0;
  peerInfo.encrypt = false;

  // เชื่อมต่ออุปกรณ์ที่ต้องการสื่อสาร
  if (esp_now_add_peer(&peerInfo) != ESP_OK) {
    Serial.println("Failed to add peer");
    return;
  }
  
  delay(1000);
}

void loop() {
  Serial.print("park :");
  Serial.println(park);

/*
  int b1_state = Button1.read();
//  Serial.print("button1:");
//  Serial.println(b1_state);
  int b2_state = Button2.read();
//  Serial.print("button2:");
//  Serial.println(b2_state);
  int b3_state = Button3.read();
//  Serial.print("button3:");
//  Serial.println(b3_state);
  int b4_state = Button4.read();
//  Serial.print("button4:");
//  Serial.println(b4_state);
  int b5_state = Button5.read();
//  Serial.print("button5:");
//  Serial.println(b5_state);
  int b6_state = Button6.read();
//  Serial.print("button6:");
//  Serial.println(b6_state);
  delay(100);
  cnt++;
*/

  s1[0] = Button1.read();
  s1[1] = Button2.read();
  s1[2] = Button3.read();
  s1[3] = Button4.read();
  s1[4] = Button5.read();
  s1[5] = Button6.read();
  s1[6] = Button7.read();
  delay(100);

  Serial.print("button1:");
  Serial.println(s1[0]);
  Serial.print("button2:");
  Serial.println(s1[1]);
  Serial.print("button3:");
  Serial.println(s1[2]);
  Serial.print("button4:");
  Serial.println(s1[3]);
  Serial.print("button5:");
  Serial.println(s1[4]);
  Serial.print("button6:");
  Serial.println(s1[5]);

  Serial.print("c1:");
  Serial.println(c1);

  display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(WHITE);
  display.setCursor(0, 10);
//  // Display static text
//  display.println("Input your password2 :");
//  display.display(); 

if (s1[6] == 1) {
  park = 0;
  c1 = 0;
}
if (park == 1) {
  if (p1_state == 0) {
//    Serial.print("p1_state :");
//    Serial.println(p1_state);
    display.println("------ PARK 1 ------");
    display.println("   ");
    display.println("Input your password :");
    display.println("   ");
    display.display(); 
    if (s1[5] == 1) {
      c1 = 0;
    }else if (c1 == 4 && s1[4] == 1) {
      p1_state = 1;
      c1 = 0;
      display.clearDisplay();
    }else if (c1 < 4) {
      for(i=0;i<4;i++) {
        if (s1[i] == 1) {
          password1[c1] = i;
          c1++;
        }
      }
    }
    for(i=0;i<c1;i++) {
      display.setTextSize(2);
      display.print("*");
      display.display(); 
    }
  }else if(p1_state == 1) {
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.setCursor(0, 10);
    display.println("------ PARK 1 ------");
    display.println("   ");
    display.println("Please enter your ");
    display.println("password to unlock: ");
    display.println("   ");
    display.display(); 
    if (s1[5] == 1) {
      c1 = 0;
    }else if (c1 == 4 && s1[4] == 1) {
      check1 = 1;
      for(i=0;i<4;i++){
        if (password1[i] != input1[i]) {
          check1 = 0;
        }
      }
      if (check1 == 0) {
        buzzer = 1;
        // sent to buzzer
        display.clearDisplay();
        display.setTextSize(1);
        display.setTextColor(WHITE);
        display.setCursor(0, 10);
        display.println("------ PARK 1 ------");
        display.println("   ");
        display.println("Password incorrect ");
        display.display(); 
        delay(1000);
      }else {
        p1_state = 0;
        display.clearDisplay();
        display.setTextSize(1);
        display.setTextColor(WHITE);
        display.setCursor(0, 10);
        display.println("------ PARK 1 ------");
        display.println("   ");
        display.println("      Unlock !!");
        display.display(); 
        delay(1000);
        // sent to survo and web 
      }
      c1 = 0;
    }else if (c1 < 4) {
      for(i=0;i<4;i++) {
        if (s1[i] == 1) {
          input1[c1] = i;
          c1++;
        }
      }
    }
    for(i=0;i<c1;i++) {
      display.setTextSize(2);
      display.print("*");
      display.display(); 
    }
  }
}else if(park == 2){
  if (p2_state == 0) {
//    Serial.print("p2_state :");
//    Serial.println(p2_state);
    display.println("------ PARK 2 ------");
    display.println("   ");
    display.println("Input your password :");
    display.println("   ");
    display.display(); 
    if (s1[5] == 1) {
      c1 = 0;
    }else if (c1 == 4 && s1[4] == 1) {
      p2_state = 1;
      c1 = 0;
      display.clearDisplay();
    }else if (c1 < 4) {
      for(i=0;i<4;i++) {
        if (s1[i] == 1) {
          password2[c1] = i;
          c1++;
        }
      }
    }
    for(i=0;i<c1;i++) {
      display.setTextSize(2);
      display.print("*");
      display.display(); 
    }
  }else if(p2_state == 1) {
    display.setTextSize(1);
    display.setTextColor(WHITE);
    display.setCursor(0, 10);
    display.println("------ PARK 2 ------");
    display.println("   ");
    display.println("Please enter your ");
    display.println("password to unlock: ");
    display.println("   ");
    display.display(); 
    if (s1[5] == 1) {
      c1 = 0;
    }else if (c1 == 4 && s1[4] == 1) {
      check1 = 1;
      for(i=0;i<4;i++){
        if (password2[i] != input1[i]) {
          check1 = 0;
        }
      }
      if (check1 == 0) {
        buzzer = 1;
        // sent to buzzer
        display.clearDisplay();
        display.setTextSize(1);
        display.setTextColor(WHITE);
        display.setCursor(0, 10);
        display.println("------ PARK 2 ------");
        display.println("   ");
        display.println("Password incorrect ");
        display.display(); 
        myData.is_password_correct = 0;
        delay(1000);
      }else {
        p2_state = 0;
        display.clearDisplay();
        display.setTextSize(1);
        display.setTextColor(WHITE);
        display.setCursor(0, 10);
        display.println("------ PARK 2 ------");
        display.println("   ");
        display.println("      Unlock !!     ");
        display.display(); 
        myData.is_password_correct = 1;
        delay(1000);
        // sent to survo and web 
      }
      c1 = 0;
    }else if (c1 < 4) {
      for(i=0;i<4;i++) {
        if (s1[i] == 1) {
          input1[c1] = i;
          c1++;
        }
      }
    }
    for(i=0;i<c1;i++) {
      display.setTextSize(2);
      display.print("*");
      display.display(); 
    }
  }
}else if (park == 0) {
  display.println("Which lane do you ");
  display.println("want to park ? :");
  display.display();
  if (s1[4] == 1) {
    park = 1;
  }else if (s1[5] == 1) {

    park = 2;
  }
}
  // สั่งให้ส่งข้อมูล
  esp_err_t result = esp_now_send(broadcastAddress, (uint8_t *) &myData, sizeof(myData));

  if (result == ESP_OK) {
    Serial.println("Sent with success");
  }
  else {
    Serial.println("Error sending the data");
  }
  delay(500);
}

  
