/*
 * This ESP32 code is created by esp32io.com
 *
 * This ESP32 code is released in the public domain
 *
 * For more detail (instruction and wiring diagram), visit https://esp32io.com/tutorials/esp32-light-sensor
 */

#include <Arduino.h>
#include <esp_now.h>
#include <WiFi.h>

#define LIGHT_SENSOR_PIN 36 // ESP32 pin GIOP36 (ADC,0)
#define LIGHT2_SENSOR_PIN 39 // ESP32 pin GIOP36 (ADC,0)
#define LED_RED_PIN 32
#define LED_GREEN_PIN 33
#define LED2_RED_PIN 25
#define LED2_GREEN_PIN 26

//uint8_t broadcastAddress[] = {0xE8, 0x68, 0xE7, 0x19, 0xAA, 0xB0};//ส่งไปหาเฉพาะ mac address
uint8_t broadcastAddress[] = { 0xE8, 0xDB, 0x84, 0x00, 0xDC, 0xF0 }; //servo
//uint8_t broadcastAddress[] = { 0xE8, 0xDB, 0x84, 0x01, 0x21, 0x54 }; //server
typedef struct struct_message { // สร้างตัวแปรแพ็จเกจแบบ struct
  int which_board;
  int is_park1;
  int is_park2;
  int is_password_correct;
} struct_message;

struct_message myData; // ตัวแปรแพ็คเกจที่ต้องการส่ง

int ldr1_state = 0;
int ldr2_state = 0;

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) {
  //Serial.print("\r\nLast Packet Send Status:\t");
  //Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Delivery Success" : "Delivery Fail");
}


void setup() {
  // initialize serial communication at 9600 bits per second:
  Serial.begin(115200);
  pinMode(LED_RED_PIN,OUTPUT);
  pinMode(LED_GREEN_PIN,OUTPUT);
  pinMode(LED2_RED_PIN,OUTPUT);
  pinMode(LED2_GREEN_PIN,OUTPUT);

  WiFi.mode(WIFI_STA);

  // สั่งให้เริ่ม ESP-NOW
  if (esp_now_init() != ESP_OK) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }

  //เมื่อส่งให้ทำฟังก์ชั่น OnDataSend ที่เราสร้างขึ้น
  esp_now_register_send_cb(OnDataSent);

  // Register peer
  esp_now_peer_info_t peerInfo;
  memcpy(peerInfo.peer_addr, broadcastAddress, 6);
  peerInfo.channel = 0;
  peerInfo.encrypt = false;

  // เชื่อมต่ออุปกรณ์ที่ต้องการสื่อสาร
  if (esp_now_add_peer(&peerInfo) != ESP_OK) {
    Serial.println("Failed to add peer");
    return;
  }
}

void loop() {
  // reads the input on analog pin (value between 0 and 4095)
  //int LDRPin = GPIO_NUM_36;
  int analogValue = analogRead(LIGHT_SENSOR_PIN);
  int analogValue2 = analogRead(LIGHT2_SENSOR_PIN);
//  Serial.println();   
//  Serial.println(analogValue ); 
//  Serial.println(analogValue2 );
//  Serial.println();   
  // the raw analog reading

  // We'll have a few threshholds, qualitatively determined
  if (analogValue >= 3900) {
     //Serial.println(" 1empthy ");
     digitalWrite (LED_GREEN_PIN, HIGH);
     digitalWrite (LED_RED_PIN, LOW);
     ldr1_state = 1;
  } else {
     //Serial.println(" 1close ");
     digitalWrite (LED_RED_PIN, HIGH);
     digitalWrite (LED_GREEN_PIN, LOW);
     ldr1_state = 0;
  }

  if (analogValue2 >= 3900) {
//     Serial.println(" 2empthy ");
     digitalWrite (LED2_GREEN_PIN, HIGH);
     digitalWrite (LED2_RED_PIN, LOW);
     ldr2_state = 1;
  } else {
//     Serial.println(" 2close ");
     digitalWrite (LED2_RED_PIN, HIGH);
     digitalWrite (LED2_GREEN_PIN, LOW);
     ldr2_state = 0;
  }


  // สร้างตัวแปรแพ็คเกจที่ต้องการส่ง
  myData.is_park1 = ldr1_state;
  myData.is_park2 = ldr2_state;
  myData.which_board = 1;

  // สั่งให้ส่งข้อมูล
  esp_err_t result = esp_now_send(broadcastAddress, (uint8_t *) &myData, sizeof(myData));

  if (result == ESP_OK) {
    Serial.println("Sent with success");
  }
  else {
    Serial.println("Error sending the data");
  }
  delay(500);

}
