#include <WiFi.h>
#include <Wire.h>
#include <esp_now.h>

// Replace with your network credentials
const char* ssid = "iPhone@43"; //Per
const char* password = "bigbigbig";
//const char* ssid = "vivo 2000"; //Belle
//const char* password = "bellebelle"; 
//const char* ssid = "Galaxy A3200DF";  //Nine
//const char* password = "jvmi3336";
//const char* ssid = "iPhone pipi";
//const char* password = "bigbigbig";

unsigned long previousMillis = 0;  // Stores last time temperature was published
const long interval = 1000; 

// Set web server port number to 80
WiFiServer server(80);

// Variable to store the HTTP request
String header;

// Variable to store state of parks
int p01 = 1;
int p02 = 1;

typedef struct struct_message { // สร้างตัวแปรแพ็จเกจแบบ struct
  int which_board;
  int is_park1;
  int is_park2;
  int is_password_correct1;
  int is_password_correct2;
} struct_message;

struct_message myData; // ตัวแปรแพ็คเกจที่ต้องการส่ง

void OnDataRecv(const uint8_t * mac, const uint8_t *incomingData, int len) {
  memcpy(&myData, incomingData, sizeof(myData));

  if (myData.which_board == 1){
    Serial.print("mydata.is_park1 : ");
    Serial.println(myData.is_park1);
//    Serial.print("mydata.is_password_correct1 : ");
//    Serial.println(myData.is_password_correct1);
    if (myData.is_park1 == 0){
      p01 = 1;  //not empty
    }
    else{
      p01 = 0;  //empty
    }
    Serial.print("mydata.is_park2 : ");
    Serial.println(myData.is_park2);
//    Serial.print("mydata.is_password_correct2 : ");
//    Serial.println(myData.is_password_correct2);
    if (myData.is_park2 == 0){
      p02 = 1;  //not empty
    }
    else{
      p02 = 0;  //empty
    }
  }
}

// Auxiliar variables to store the current output state
String output26State = "off";
String output27State = "off";

// Assign output variables to GPIO pins
const int output26 = 26;
const int output27 = 27;

// Current time
unsigned long currentTime = millis();
// Previous time
unsigned long previousTime = 0; 
// Define timeout time in milliseconds (example: 2000ms = 2s)
const long timeoutTime = 2000;

void setup() {
  Wire.begin(9);
  Serial.begin(115200);
  // Initialize the output variables as outputs
  pinMode(output26, OUTPUT);
  pinMode(output27, OUTPUT);
  // Set outputs to LOW
  digitalWrite(output26, LOW);
  digitalWrite(output27, LOW);

  // Connect to Wi-Fi network with SSID and password
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  // Print local IP address and start web server
  Serial.println("");
  Serial.println("WiFi connected.");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  server.begin();

  WiFi.mode(WIFI_STA);
  Serial.println(WiFi.macAddress());

  // Init ESP-NOW
  if (esp_now_init() != ESP_OK) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }
  // เมื่อรับข้อมูลมา ให้ทำในฟังก์ชั่น OnDataRecv ที่เราสร้างไว้
//  esp_now_register_recv_cb(OnDataRecv);
}

void loop(){
//  Serial.print("mydata.is_park1 : ");
//  Serial.println(myData.is_park1);
//  Serial.print("mydata.is_park2 : ");
//  Serial.println(myData.is_park2);
  
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis >= interval) {
    // Save the last time a new reading was published
    previousMillis = currentMillis;

//  Wire.requestFrom(8, 6);   // request 6 bytes from peripheral device #8
  int x = 0;
  while (Wire.available()) {
    x = Wire.read();
    Serial.println(x);
  }
//  while (Wire.available()) { // peripheral may send less than requested
//    char c = Wire.read(); // receive a byte as character
//    Serial.print(c);         // print the character
//  }

  esp_now_register_recv_cb(OnDataRecv);
  delay(500);
  
  WiFiClient client = server.available();   // Listen for incoming clients

  if (client) {                             // If a new client connects,
    currentTime = millis();
    previousTime = currentTime;
    Serial.println("New Client.");          // print a message out in the serial port
    String currentLine = "";                // make a String to hold incoming data from the client
    while (client.connected() && currentTime - previousTime <= timeoutTime) {  // loop while the client's connected
      currentTime = millis();
      if (client.available()) {             // if there's bytes to read from the client,
        char c = client.read();             // read a byte, then
        Serial.write(c);                    // print it out the serial monitor
        header += c;
        if (c == '\n') {                    // if the byte is a newline character
          // if the current line is blank, you got two newline characters in a row.
          // that's the end of the client HTTP request, so send a response:
          if (currentLine.length() == 0) {
            // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
            // and a content-type so the client knows what's coming, then a blank line:
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println("Connection: close");
            client.println();
            
            // turns the GPIOs on and off
            if (header.indexOf("GET /26/on") >= 0) {
              Serial.println("GPIO 26 on");
              output26State = "on";
              digitalWrite(output26, HIGH);
            } else if (header.indexOf("GET /26/off") >= 0) {
              Serial.println("GPIO 26 off");
              output26State = "off";
              digitalWrite(output26, LOW);
            } else if (header.indexOf("GET /27/on") >= 0) {
              Serial.println("GPIO 27 on");
              output27State = "on";
              digitalWrite(output27, HIGH);
            } else if (header.indexOf("GET /27/off") >= 0) {
              Serial.println("GPIO 27 off");
              output27State = "off";
              digitalWrite(output27, LOW);
            }
            
            // Display the HTML web page
            client.println("<!DOCTYPE html><html>");
            client.println("<head><meta charset='utf-8'/><title>SMART BIKE PARK</title>");
            client.println("<meta http-equiv='refresh' content='5'>");
            client.println("<link rel='preconnect' href='https://fonts.googleapis.com'>");
            client.println("<link rel='preconnect' href='https://fonts.gstatic.com' crossorigin>");
            client.println("<link href='https://fonts.googleapis.com/css2?family=Patrick+Hand&display=swap' rel='stylesheet'>");
            // CSS to style the on/off buttons 
            // Feel free to change the background-color and font-size attributes to fit your preferences
            client.println("<style>");
            client.println("body{background-color: #C9D7DC; font-family: 'Patrick Hand', cursive;}");
            client.println(".box{background-color: #2d2e30; width: 600px; height: 600px; margin-left: auto; margin-right: auto; margin-top: 60px; border-radius: 10px; box-shadow: rgba(14, 30, 37, 0.12) 0px 2px 4px 0px, rgba(14, 30, 37, 0.32) 0px 2px 16px 0px;}");
            client.println(".title{text-align: center; color: white; margin-top: 40px; margin-bottom: 40px; font-size: 50px;}");
            client.println(".park{display: flex; justify-content: right; height: 190px;}");
            client.println(".empty{display: flex; justify-content: right; align-items: center; background-color: #4AAE1A; color: white; width: 150px; height: 60px; margin-top: 20px; margin-right: 5px; padding-right: 20px; border-radius: 20px 0px 0px 20px; font-size: 24px;}");
            client.println(".notempty{display: flex; justify-content: right; align-items: center; background-color: #FD554B; color: white; width: 150px; height: 60px; margin-top: 20px; margin-right: 5px; padding-right: 20px; border-radius: 20px 0px 0px 20px; font-size: 24px;}");
            client.println(".box-bike{display: flex; justify-content: center; align-items: center; background-color: white; color: #A4A4A4; width: 350px; height: 190px; border-radius: 20px 0px 0px 20px; font-size: 22px;}");
            client.println("");
            client.println("");
            client.println("</style></head>");
            
            // Web Page Heading
            client.println("<body><div class='box'>");

            // Title
            client.println("<div style='display: flex; justify-content: center;'><h1 class='title'>SMART BIKE PARK</h1></div>");

            // Park - 01
            client.println("<div class='park' style='margin-bottom: 40px;'>");
            if (p01 == 0) {
              // P-01 Empty
              client.println("<div class='empty'>Empty</div><div class='box-bike'>P - 01</div>");
            } else {
              // P-01 Not Empty
              client.println("<div class='notempty'>Not Empty</div>");
              client.println("<div class='box-bike'><img src='https://cdn.pixabay.com/photo/2013/07/13/13/22/bike-160920_1280.png' alt='Parliament Hill' width='240'></div>");
            }
            // P-01 End
            client.println("</div>");

            // Park - 02
            client.println("<div class='park' style='margin-bottom: 40px;'>");
            if (p02 == 0) {
              // P-02 Empty
              client.println("<div class='empty'>Empty</div><div class='box-bike'>P - 02</div>");
            } else {
              // P-02 Not Empty
              client.println("<div class='notempty'>Not Empty</div>");
              client.println("<div class='box-bike'><img src='https://cdn.pixabay.com/photo/2013/07/13/13/22/bike-160920_1280.png' alt='Parliament Hill' width='240'></div>");
            }
            // P-02 End
            client.println("</div>");
            
            // Web Page End
            client.println("</body></html>");
            
            // The HTTP response ends with another blank line
            client.println();
            // Break out of the while loop
            break;
          } else { // if you got a newline, then clear currentLine
            currentLine = "";
          }
        } else if (c != '\r') {  // if you got anything else but a carriage return character,
          currentLine += c;      // add it to the end of the currentLine
        }
      }
    }
    // Clear the header variable
    header = "";
    // Close the connection
    client.stop();
    Serial.println("Client disconnected.");
    Serial.println("");
  }
  }
}
