#include <Arduino.h>
#include <ESP32Servo.h>
#include <Debounce.h>
#include <esp_now.h>
#include <WiFi.h>

int freq = 2000;
int channel = 0; 
int resolution = 8;

typedef struct struct_message {
    int which_board;
    int is_park1;
    int is_park2;
    int is_password_correct1;
    int is_password_correct2;
} struct_message;

struct_message myData;


Servo myservo1; //ประกาศตัวแปรแทน Servo
Servo myservo2; //ประกาศตัวแปรแทน Servo


Debounce Button14(GPIO_NUM_14, 100, true );
Debounce Button19(GPIO_NUM_19, 100, true );
static const int sv1 = GPIO_NUM_13;
static const int sv2 = GPIO_NUM_26;

unsigned long lastDebounceTime = 0;  // the last time the output pin was toggled
unsigned long debounceDelay = 50;
int b14_state;
int pw1;
int last_pw1;
int pw2;
int last_pw2;
int pos;
int sv1_status = 1;
int sv2_status = 1;
int park1_status ;
int park2_status ;
static const int buzzer = GPIO_NUM_27;
static const int button14 = GPIO_NUM_14;
static const int button19 = GPIO_NUM_19;

void OnDataRecv(const uint8_t * mac, const uint8_t *incomingData, int len) {
  memcpy(&myData, incomingData, sizeof(myData));
  if(myData.which_board == 1){
//    Serial.println("======ldr && led=====");
      Serial.print("Is park1: ");
      Serial.println(myData.is_park1);
      Serial.print("Is park2: ");
      Serial.println(myData.is_park2);
  }
  else{
//    Serial.println("======sw && olcd=====");
      Serial.print("is_password_correct1 : ");
      Serial.println(myData.is_password_correct1);
      Serial.print("is_password_correct2 : ");
      Serial.println(myData.is_password_correct2);
      Serial.println();
  }

  if(myData.which_board == 0){
      pw1 = myData.is_password_correct1;
      pw2 = myData.is_password_correct2; 
  }
  else if(myData.which_board == 1){
      park1_status = myData.is_park1;
      park2_status = myData.is_park2;
  }
  
  delay(500);
}

void setup()
{
  Serial.println("in setup");
  Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  Serial.print("mac :");
  Serial.println(WiFi.macAddress());
  pinMode(buzzer, OUTPUT);
  pinMode(button14, INPUT_PULLUP);
  pinMode(button19, INPUT_PULLUP);
  myservo1.attach(sv1);
  myservo1.write(-90);              // tell servo to go to position in variable 'pos'
    
  myservo2.attach(sv2);
  myservo2.write(-90);

  digitalWrite(buzzer, HIGH);

  if (esp_now_init() != ESP_OK) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }
  // เมื่อรับข้อมูลมา ให้ทำในฟังก์ชั่น OnDataRecv ที่เราสร้างไว้
  esp_now_register_recv_cb(OnDataRecv);
}
void loop(){
  if(last_pw1 == 0 && pw1 == 1){
    if(sv1_status == 1){
      myservo1.attach(sv1);
      myservo1.write(180);              // tell servo to go to position in variable 'pos'
      
      sv1_status = 0;
    }
    delay(15);                       // waits 15ms for the servo to reach the position
  } 
  if(last_pw1 == 1 && pw1 == 0){
    if(sv1_status == 0){
      myservo1.attach(sv1);
      myservo1.write(-90);              // tell servo to go to position in variable 'pos'
    
      sv1_status = 1;
    }
    delay(15);                       // waits 15ms for the servo to reach the position
  } 
  if(last_pw2 == 0 && pw2 == 1){
    if(sv2_status == 1){
      myservo2.attach(sv2);
      myservo2.write(180);              // tell servo to go to position in variable 'pos'
      
      sv2_status = 0;
    }
    delay(15);                       // waits 15ms for the servo to reach the position
  } 
  if(last_pw2 == 1 && pw2 == 0){
    if(sv2_status == 0){
      myservo2.attach(sv2);
      myservo2.write(-90);              // tell servo to go to position in variable 'pos'
    
      sv2_status = 1;
    }
    delay(15);                       // waits 15ms for the servo to reach the position
  }
  
  
  last_pw1 = pw1;
  last_pw2 = pw2;

  Serial.println("pw1 last_pw1 park1_status b14_status");
  Serial.print(pw1);
  Serial.print(" ");
  Serial.print(last_pw1);
  Serial.print(" ");
  Serial.print(park1_status);
  Serial.print(" ");
  Serial.println(b14_state);
  if (pw1 == 1 && last_pw1 == 1){
    if (park1_status == 1 ){
//     if (b14_state == 0){ //not press
       digitalWrite(buzzer, LOW);  //lound
//     b14_state = Button14.read();
       delay(1000);
       digitalWrite(buzzer, HIGH); 
//     } 
//     else{
//       digitalWrite(buzzer, HIGH); 
//     }
    }
  }
  else{
    b14_state = Button14.read();  
  }
  
  if (pw2 == 1 && last_pw2 == 1){
    if (park2_status == 1 ){
//     if (b14_state == 0){
       digitalWrite(buzzer, LOW);
//     b14_state = Button14.read();
       delay(1000);
       digitalWrite(buzzer, HIGH); 
//      } 
//      else{
//        digitalWrite(buzzer, HIGH); 
//      }
    }
  }
  else{
    b14_state = Button14.read();  
  }
  
  delay(1000);
  
}
